﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using com.cruxomatic.views.Administration;
using com.cruxomatic.controllers.Administration;

public partial class Administration_ManageCompany : BaseView, IManageCompany
{
    ManageCompanyController _controller = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            SetSiteMap();
        }
        _controller = new ManageCompanyController(this);
        _controller.InitView(IsPostBack);

    }

    #region Site Map
    private void SetSiteMap()
    {
        string query = Request.Url.Query;
        UrlTreeNodeItems.ManageMyOrganization = UrlTreeNodeItems.CreateNode("Manage My Company",
                                                                          "/Administration/ManageCompany.aspx" + query,
                                                                          "ManageMyCompany",
                                                                          UrlTreeNodeItems.Admin);
        
        if (Request.UrlReferrer != null)
        {
            if (Request.UrlReferrer.ToString().Contains(UrlTreeNodeItems.ManageOrganization.Url))
                UrlTreeNodeItems.ManageMyOrganization = UrlTreeNodeItems.CreateNode("Manage My Company",
                                                                          "/Administration/ManageCompany.aspx" + query,
                                                                          "ManageMyCompany2",
                                                                          UrlTreeNodeItems.ManageOrganization);
        }
        UrlTreeNodeItems.SetSiteNavigation(PageSiteMap, UrlTreeNodeItems.ManageMyOrganization);
    }
    #endregion

    #region IManageCompany Members

    public int CompanyID
    {
        get
        {
            return int.Parse(Request.Params["id"].ToString());
        }

    }



    public bool ManageDepartments
    {
        get
        {
            return pnlManageDepartments.Visible;
        }
        set
        {
            pnlManageDepartments.Visible = value;
            pnlManageDepartmentsPicture.Visible = value;
        }
    }

    public bool ManageUsers
    {
        get
        {
            return pnlManageUsers.Visible;
        }
        set
        {
            pnlManageUsers.Visible = value;
            pnlManageUsersPicture.Visible = value;
        }
    }

    public bool ManageLocations
    {
        get
        {
            return pnlManageLocations.Visible;
        }
        set
        {
            pnlManageLocations.Visible = value;
            pnlManageLocationsPicture.Visible = value;
        }
    }

    #endregion
    protected void lnkLocations_Click(object sender, EventArgs e)
    {
        _controller.ManageLocations();
    }
    protected void lnkManageDepartments_Click(object sender, EventArgs e)
    {
        _controller.ManageDepartments();
    }
    protected void lnkManageUsers_Click(object sender, EventArgs e)
    {
        _controller.ManageUsers();
    }
}
