﻿<%@ WebService Language="C#" Class="QuickSearchService" %>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using com.cruxomatic.items.quicksearch.ConfigParser;
using com.cruxomatic.items.quicksearch.DTO;


/// <summary>
/// Summary description for QuickSearchService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
[System.Web.Script.Services.ScriptService]
public class QuickSearchService : System.Web.Services.WebService
{

    public QuickSearchService()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="prefixText"></param>
    /// <param name="count"></param>
    /// <param name="contextKey">Separated by "|". example and syntax : "Security Key|User Roles"</param>
    /// <returns></returns>
    [WebMethod]
    public string[] GetAutoCompleteSearchItems(string prefixText, int count, string contextKey)
    {
        string securityKey = contextKey.Split('|')[0];
        if (!securityKey.Equals("ef0rce!@##@!")) return new[] { "Please provide security key!" };

        prefixText = prefixText.ToLower();
        string user = contextKey.Split('|')[1];
        List<string> userRoles = contextKey.Split('|')[2].Split(',').ToList();

        //return GetQuickSerachModule(userRoles, prefixText, count);
        return prefixText.StartsWith("#")
                ? GetCommandModule(userRoles, prefixText, count)
                : GetQuickSerachModule(userRoles, prefixText, count);
    }

    private static string[] GetCommandModule(List<string> userRoles, string prefixText, int count)
    {
        List<QuickSearchCommandItem> commandItems = CommandConfigParser.GetQuickSearchCommandNodeItems();
        List<QuickSearchCommandItem> commandItemsRoleBased = commandItems.Where(q => IsUserInRoles(userRoles, q.Roles)).ToList();
        commandItems = commandItemsRoleBased.Where(n => n.Help.ToLower().StartsWith(prefixText)).OrderBy(n => n.Name).Take(count).ToList();
        if (commandItems.Count == 0)
        {
            string initialHelpText = prefixText.Split('/')[0];
            if (!string.IsNullOrEmpty(initialHelpText))
            {
                commandItems = commandItemsRoleBased.Where(n => n.Help.ToLower().Split('/')[0].Equals(initialHelpText)).ToList();
            }
        }
        return commandItems.Select(item =>
                               AjaxControlToolkit.AutoCompleteExtender.CreateAutoCompleteItem
                                   (item.Help, item.Target + "|" + HttpContext.Current.Request.ApplicationPath + "/command/" + item.Name)
                                    ).
                                   ToArray();
    }

    private static string[] GetQuickSerachModule(List<string> userRoles, string prefixText, int count)
    {
        List<QuickSearchItem> qsItems = CommandConfigParser.GetQuickSearchItems().Where(q => IsUserInRoles(userRoles, q.Roles)).ToList();
        qsItems = qsItems.Where(n => n.Caption.ToLower().Contains(prefixText)).OrderBy(n => n.Caption).Take(count).ToList();
        return qsItems.Select(item =>
                               AjaxControlToolkit.AutoCompleteExtender.CreateAutoCompleteItem
                                   (item.Caption, item.Target + "|" + HttpContext.Current.Request.ApplicationPath + item.Url)).
                                   ToArray();
    }

    private static bool IsUserInRoles(List<string> userRoles, List<string> rolesInLinks)
    {
        return userRoles.Any(role => rolesInLinks.Contains(role) || rolesInLinks.Contains("*"));
    }
}