﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using com.eforceglobal.crux.web.wrokflows;

public partial class RolValidation : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            LoadData();
        }
    }
    //protected void btnDashboard_Click(object sender, EventArgs e)
    //{
    //    Response.Redirect("~/WorkFlowDemo/WorkFlowDashBoard.aspx");
    //}
    protected void btnSave_Click(object sender, EventArgs e)
    {
        new PurchaseOrderController().SubmitPurchaseQuantityRequest(new PurchaseOrderInfo
        {
            PurchaseOrderId = Convert.ToInt64(lblOderId.Text),
            ItemName = txtItemName.Text,
            Itemquantity = Convert.ToInt64(txtItemQuantity.Text),
            PurchaseOrderDate = Convert.ToDateTime(txtOderDate.Text),
            IsCredit = chkCredit.Checked,
            Price = Convert.ToDecimal(txtPrice.Text),
            WorkFlowDate = DateTime.Now,
            WorkflowInstanceId = Convert.ToInt32(lblInstanceId.Text),
        }, Session["usersession"].ToString());
        pnlRol.Visible = false;
        LoadData();
    }
    protected void btnReject_Click(object sender, EventArgs e)
    {
        new PurchaseOrderController().RejectedFromROLValidation(new PurchaseOrderInfo
        {
            PurchaseOrderId = Convert.ToInt64(lblOderId.Text),
            ItemName = txtItemName.Text,
            Itemquantity = Convert.ToInt64(txtItemQuantity.Text),
            PurchaseOrderDate = Convert.ToDateTime(txtOderDate.Text),
            IsCredit = chkCredit.Checked,
            Price = Convert.ToDecimal(txtPrice.Text),
            WorkFlowDate = DateTime.Now,
            WorkflowInstanceId = Convert.ToInt32(lblInstanceId.Text),
        }, Session["usersession"].ToString());
        pnlRol.Visible = false;
        LoadData();

    }
    protected void btnCancel_Click(object sender, EventArgs e)
    {
        pnlRol.Visible = false;
    }
    private void LoadData()
    {
        List<PurchaseOrderInfo> lst = new PurchaseOrderController().PurchaseOrdersByStateName("ROLValidation");
        grdWorkFlows.DataSource = lst;
        grdWorkFlows.DataBind();
    }
    public void grdWorkFlows_RowCommand(object sender, CommandEventArgs e)
    {
        int workflowInstanceId = Convert.ToInt32(e.CommandArgument.ToString());
        var purchaseOrderInfo = new PurchaseOrderController().PurchaseOrdersByWorkFlowInstanceId(workflowInstanceId);
        lblOderId.Text = purchaseOrderInfo.PurchaseOrderId.ToString();
        lblInstanceId.Text = purchaseOrderInfo.WorkflowInstanceId.ToString();
        txtItemName.Text = purchaseOrderInfo.ItemName;
        txtItemQuantity.Text = purchaseOrderInfo.Itemquantity.ToString();
        txtOderDate.Text = purchaseOrderInfo.PurchaseOrderDate.ToString();
        txtPrice.Text = purchaseOrderInfo.Price.ToString();
        chkCredit.Checked = purchaseOrderInfo.IsCredit;
        pnlRol.Visible = true;
    }
}
