﻿using com.cruxomatic.configuration;
using com.cruxomatic.configuration.FeatureManager;
using com.cruxomatic.views.Administration;
using com.cruxomatic.DTOs;
using com.cruxomatic.security;

namespace com.cruxomatic.controllers.Administration
{
    public class ManageCompanyController
    {
        readonly IManageCompany _view;
        public ManageCompanyController(IManageCompany view)
        {
            _view = view;
        }

        public void InitView(bool IsPostBack)
        {
            if (!IsPostBack)
            {
                CheckValidity();
                IFeatureManager featureManager = FeatureManagerFactory.GetFeatureManager();
                _view.ManageDepartments = featureManager.IsFeatureSupported("ManageDepartments");
                _view.ManageLocations = featureManager.IsFeatureSupported("ManageLocations");
            }
        }

        private void CheckValidity()
        {
            ICruxSecurityManager cruxSecurityManager = CruxSecurityManagerFactory.GetSecurityManager();
            SessionData sessionData = new SessionData();
            UserInformation currentuser = (UserInformation)sessionData.CurrentUser;
            if (!cruxSecurityManager.IsUserSuperAdminOrCompanyAdmin(currentuser, _view.CompanyID))
                NavigationController.OpenErrorPage("803");

        }


        
        public void ManageLocations()
        {
            NavigationController.OpenView("ManageLocations", _view.CompanyID);
        }

        public void ManageDepartments()
        {
            NavigationController.OpenView("ManageDepartments", _view.CompanyID);
        }

        public void ManageUsers()
        {
            NavigationController.OpenView("ManageUsers", _view.CompanyID);
        }

       
    }
}
