﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using com.cruxomatic.configuration.FeatureManager;
using com.cruxomatic.security.EncryptionAndHashing.Enums;
using com.cruxomatic.security;
using com.cruxomatic.BusinessFacades;
using com.cruxomatic.DTOs;
using com.cruxomatic.configuration;

namespace com.cruxomatic.controllers.Administration
{
    public class UserController
    {
        public static PasswordStorageType GetPasswordStorageType()
        {
            return CruxConfigurationManager.GetPasswordStorageType();
        }

        public static void SaveUser(UserInformation userInformation)
        {
            UserFacade userFacade = new UserFacade();
            PasswordStorageType passwordStorageType = CruxConfigurationManager.GetPasswordStorageType();
            IFeatureManager featureManager = FeatureManagerFactory.GetFeatureManager();
            bool isFeatureSupported = featureManager.IsFeatureSupported("SavePreviousPasswords");
            userFacade.SaveUser(userInformation, passwordStorageType, isFeatureSupported);
        }
    }
}
